/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 27/03/2018
 --------------------------------------------------------
*/
package com.portofolio.entity;


import org.hibernate.annotations.ForeignKey;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.AKHIR_KURUNG;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.AWAL_KURUNG;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.FLOAT;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.INTEGER;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.INTEGER;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.VARCHAR;

import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Index;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Version;
import javax.validation.constraints.NotNull;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.portofolio.entity.KelompokTransaksi;
import com.portofolio.entity.Profile;
import com.portofolio.entity.StrukturNomor;
import com.portofolio.entity.vo.KelompokTransaksiDetailId;

import org.hibernate.annotations.Type;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Entity
@Table(name = "KelompokTransaksiDetail_M", indexes = {
		@Index(name = "KelompokTransaksiDetail_M_Index", columnList = "statusEnabled", unique = false) })
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@JsonIgnoreProperties({ "hibernateLazyInitializer", "handler" })
public class KelompokTransaksiDetail {

	@EmbeddedId
	private KelompokTransaksiDetailId id;

	private static final String cDefKdStrukturNomor = INTEGER;
	@Column(name = "KdStrukturNomor", columnDefinition = cDefKdStrukturNomor)
	private Integer kdStrukturNomor;

	private static final String cDefisRealSK = INTEGER;
	@Column(name = "isRealSK", columnDefinition = cDefisRealSK)
	private Integer isRealSK;

	private static final String cDefQtyHariMinPostingBefore = INTEGER;
	@Column(name = "QtyHariMinPostingBefore", columnDefinition = cDefQtyHariMinPostingBefore)
	private Integer qtyHariMinPostingBefore;

	private static final String cDefQtyJamMaxPostingBefore = FLOAT;
	@Column(name = "QtyJamMaxPostingBefore", columnDefinition = cDefQtyJamMaxPostingBefore)
	private Float qtyJamMaxPostingBefore;

	private static final String cDefQtyHariActiveAfterSK = INTEGER;
	@Column(name = "QtyHariActiveAfterSK", columnDefinition = cDefQtyHariActiveAfterSK)
	private Integer qtyHariActiveAfterSK;

	private static final String cDefQtyHariMinNewPosting = FLOAT;
	@Column(name = "QtyHariMinNewPosting", columnDefinition = cDefQtyHariMinNewPosting)
	private Float qtyHariMinNewPosting;

	private static final String cDefQtyHariMaxPostingExpired = INTEGER;
	@Column(name = "QtyHariMaxPostingExpired", columnDefinition = cDefQtyHariMaxPostingExpired)
	private Integer qtyHariMaxPostingExpired;

	private static final String cDefQtyJamMaxPostingExpired = FLOAT;
	@Column(name = "QtyJamMaxPostingExpired", columnDefinition = cDefQtyJamMaxPostingExpired)
	private Float qtyJamMaxPostingExpired;

	private static final String cDefisCostInOut = INTEGER;
	@Column(name = "isCostInOut", columnDefinition = cDefisCostInOut)
	private Integer isCostInOut;

	private static final String cDefStatusEnabled = INTEGER;
	@Column(name = "StatusEnabled", columnDefinition = cDefStatusEnabled)
	@NotNull(message = "kelompoktransaksidetail.statusenabled.notnull")
	@Type(type = "org.hibernate.type.NumericBooleanType") private Boolean statusEnabled;

	private static final String cDefNoRec = VARCHAR + AWAL_KURUNG + 36 + AKHIR_KURUNG;
	@Column(name = "NoRec", columnDefinition = cDefNoRec)
	@NotNull(message = "kelompoktransaksidetail.norec.notnull")
	private String noRec;

	private static final String cDefVersion = INTEGER;
	@Version
	@Column(name = "version", nullable = false, columnDefinition = cDefVersion)
	@NotNull(message = "kelompoktransaksidetail.version.notnull")
	private Integer version;

	@ManyToOne(fetch = FetchType.LAZY)
	@JsonIgnore
	@JoinColumns({
			@JoinColumn(name = "KdProfile", referencedColumnName = "KdProfile", insertable = false, updatable = false), })
	//@ForeignKey(name="none")
	private Profile profile;

	@ManyToOne(fetch = FetchType.LAZY)
	@JsonIgnore
	@JoinColumns({
			@JoinColumn(name = "KdKelompokTransaksi", referencedColumnName = "KdKelompokTransaksi", insertable = false, updatable = false), })
	//@ForeignKey(name="none")
	private KelompokTransaksi kelompokTransaksi;
	

//	 @ManyToOne(fetch= FetchType.LAZY)
//	    @JsonIgnore
//	    @JoinColumns({
//	        @JoinColumn(name="KdProfile", referencedColumnName="KdProfile",insertable=false, updatable=false),
//	        @JoinColumn(name="KdStrukturNomor", referencedColumnName="KdStrukturNomor",insertable=false, updatable=false),
//	    })
//	    //@ForeignKey(name="none")
//	     private StrukturNomor strukturNomor;
//	
}
